{include file="header.tpl"}
<link rel="stylesheet" href="css/jquery-ui.min.css">
<script type="text/javascript" src="js/jquery-ui-1.12.1.min.js"></script>
<script type="text/javascript" src="js/dropoff.js"></script>

<script type="text/javascript">
<!--

// Email regex
var emailFormatRegex = /(\S+@\S+)/;
var emailBracketRegex = /<(\S+@\S+)>/;
var emailRegex = {$validEmailRegexp};

var presetToName = '{$recipName_1}';
var presetToEmail = '{$recipEmail_1}';

var maxFileSize = '{$maxBytesForFileInt}';
var maxTotalSize = '{$maxBytesForDropoffInt}';
var maxChecksumSize = '{$maxBytesForChecksum}';

// Library information
var usingLibrary = '{$usingLibrary}';
var library = {$library};

var recipient_id = 1;
// The number of files we have, which will be in range 1..n
var num_files = 0;
var totalbytes = 0;
var file_objects = [];
var file_descs = [];
var fileInLibrary = []; // true => file is library, false => file is upload
var maxNoteLength = {$maxNoteLength};
var noteLength = 0;
var checksumUnticked = false;

// Does this browser support drag and drop file selection?
var isAdvancedUpload = function() {
  var div = document.createElement('div');
  return (('draggable' in div) ||
          ('ondragstart' in div && 'ondrop' in div)) &&
         'FormData' in window && 'FileReader' in window;
}();

var ignore_unload = true;
var addressbook = {$addressbook};
var addressnames = [];
var addressmails = [];
var fulladdressmails = [];
var fulladdressmap = [];
$.each(addressbook,function(i,item){
  var fullmail = item['name']+' <'+item['email'] + '>';
  if ($.inArray(item['name'],addressnames)==-1)  addressnames.push(item['name']);
  if ($.inArray(item['email'],addressmails)==-1) addressmails.push(item['email']);
  if ($.inArray(fullmail,fulladdressmails)==-1)  fulladdressmails.push(fullmail);fulladdressmap[fullmail]=item;
});

function addAddressBook () {
	$('#recipEmail').autocomplete({
         	source:addressmails,
		appendTo:$('#recipEmail').parent()
        }).autocomplete('widget').css('text-align','left');
 	$('#recipName').autocomplete({
                source:fulladdressmails,
                appendTo:$('#recipName').parent(),
		select: function(e,ui){
			$('#recipName').val(fulladdressmap[ui.item.label].name);
			$('#recipEmail').val(fulladdressmap[ui.item.label].email);
			return false;
		}
        }).autocomplete('widget').css('text-align','left');
	$('#multipleRecipients').autocomplete({
                source:fulladdressmails,
                appendTo:$('#multipleRecipients').parent()
        }).autocomplete('widget').css('text-align','left');
} 

function updateNoteLength() {
        noteLength = $('#note').val().length;
        var left = maxNoteLength - noteLength;
        if (left < 0) {
          $('#noteLengthText').text('{t}__CHARS__ too long{/t}'.replace('__CHARS__', (0-left)));
          $('#noteLengthText').css({ "color":"red", "font-weight":"bold" });
        } else {
          $('#noteLengthText').text('{t}__CHARSLEFT__ / __MAXLENGTH__ left{/t}'.replace('__CHARSLEFT__', left).replace('__MAXLENGTH__', maxNoteLength));
          $('#noteLengthText').css({ "color":"black", "font-weight":"normal" });
        }
}

function addFilesButtonClick(e) {
	  $("#AddFiles").click();
	  e.preventDefault(); // stop navigation to #
}

var dndcollection = $(); // Keeps track of when we're in and out

function dragStart(e) {
  e.originalEvent.dataTransfer.effectAllowed = 'copy';
}

function dragOver(e) {
  e.originalEvent.dataTransfer.dropEffect = 'copy';
  if (dndcollection.length === 0) {
    $('#overlay').fadeIn('fast');
  }
  dndcollection = dndcollection.add(e.target);
}

function dragLeave(e) {
  setTimeout(function() {
    dndcollection = dndcollection.not(e.target);
    if (dndcollection.length === 0) {
      $('#overlay').fadeOut('fast');
    }
  }, 1);
}

function dragDrop(e) {
  dndcollection = $();
  $('#overlay').toggle(false); // Drop, so don't fade out slowly
  if (e.originalEvent && e.originalEvent.dataTransfer &&
      e.originalEvent && e.originalEvent.dataTransfer.files) {
    addFiles(e.originalEvent.dataTransfer.files);
  }
}

// Setup all the Drag-n-Drop stuff. We need it again if upload failed.
function setupDragDrop() {
	  $('#AddFilesButton').text('{t}Click to Add Files or Drag Them Here{/t}');
	  $('.content').on('drag dragstart dragend dragover dragenter dragleave drop', function(e) {
	    e.preventDefault();
	    e.stopPropagation();
	  })
	  .on('dragstart',          dragStart)
	  .on('dragover dragenter', dragOver)
	  .on('dragleave dragend',  dragLeave)
	  .on('drop', dragDrop);
}


//
// When document is all loaded, set it up
//
$(document).ready(function(){

    function doBeforeUnload() {
          var msg="{t}If you leave this page, you will abandon this drop-off.{/t}";
          if (ignore_unload) return; // Let the page unload
          if (window.event)
            window.event.returnValue = msg; // IE
          else
            return msg; // FF
        }

        if (window.body)
          window.body.onbeforeunload = doBeforeUnload; // IE
        else
          window.onbeforeunload = doBeforeUnload; // FF
        if (presetToName != "" && presetToEmail != "") {
          // If the preset fields are set, add the recipient.
          addRecipient(presetToName, presetToEmail);
        }

	// Check to see if maxFileSize & maxTotalFileSize is set.
	// If so we need to convert to ints from strings.
	if(maxFileSize != '')
          maxFileSize = parseInt(maxFileSize);
        else
          maxFileSize = 0;
	if(maxTotalSize != '')
          maxTotalSize = parseInt(maxTotalSize);
        else
          maxTotalSize = 0;
        if(maxChecksumSize != '')
          maxChecksumSize = parseInt(maxChecksumSize);
        else
          maxChecksumSize = 0;

	// Set the event handlers for the initial file selectors
	// Not needed after all. $("#AddFilesButton").off("click");
	$("#AddFilesButton").on("click", addFilesButtonClick);

	// Do we allow them to change either of the email tickboxes?
	// informRecipients and informPasscode
	// Both are allowed and on by default.
	if (! {$allowEmailRecipients}) {
	  $('#informRecipients').prop('checked', false).prop('disabled', true);
	  $('#informPasscode').prop('checked', false).prop('disabled', true);
    $('#informRecipientsLabel').addClass('disabledtext');
    $('#informPasscodeLabel').addClass('disabledtext');
  }
	if (! {$allowEmailPasscode}) {
	  $('#informPasscode').prop('checked', false).prop('disabled', true);
    $('#informPasscodeLabel').addClass('disabledtext');
  }
	if (! {$defaultEmailPasscode}) {
	  $('#informPasscode').prop('checked', false);
  }
  if (maxChecksumSize == 0) {
    $('#checksumFiles').prop('checked', false).prop('disabled', true);
    $('#checksumFilesLabel').addClass('disabledtext');
  } else {
    // They can untick it always. But can only tick it if total dropoff
    // size is less than maxChecksumSize.
    $('#checksumFiles').on('change', function() {
      // Did they try to tick it with a huge drop-off?
      if ($(this).is(':checked')) {
        if (totalbytes > maxChecksumSize) {
          // Too big, so untick it and yell at them.
          $('#checksumFiles').prop('checked', false);
          alert('{t escape=no}It will take too long to calculate the checksum of your drop-off.{/t}\n{t escape=no}Only drop-offs up to a maximum of __MAXSIZE__ can be checksummed.{/t}'.replace('__MAXSIZE__', formatFileSize(maxChecksumSize)));
        }
      } else {
        // They manually unticked it, so remember not to auto-tick it again
        checksumUnticked = true;
      }
    });
  }
  if ({$allowEmailRecipients} && {$allowEmailPasscode}) {
    // Uncheck informPasscode if user unchecks informRecipients
    $('#informRecipients').on('change', function() {
      if ($(this).is(':checked')) {
        // Tick informPasscode is they tick informRecips and default is yes
        if ({$defaultEmailPasscode})
          $('#informPasscode').prop('checked', true);
      } else {
        // Untick informPasscode if they untick informRecips
        $('#informPasscode').prop('checked', false);
      }
    });
    // Check informRecipients is user checks informPasscode
    $('#informPasscode').on('change', function() {
      if ($(this).is(':checked')) {
        // Tick informRecips if they tick informPasscode
        $('#informRecipients').prop('checked', true);
      }
    });
  }
        

  // Hide the files and submit button until we've got some files
  $('#uploadTable').toggle(false);
  $('#DropoffButton').toggle(false);

	// If we have drag-n-drop (dnd) support, set it up
	if (isAdvancedUpload) setupDragDrop();

  // Setup the counter & initial value for the note length
  $('#note').on("keyup", updateNoteLength);
	updateNoteLength();

	// Live event for removing recipients.
	// Live allows us to bind to any instance of .emailButton a.remove
	// now or in the future (even if the element doesn't exist yet.)
	//JQ1.9	$('.emailButton a.remove').live('click', function(){
	$(document).on("click", ".emailButton a.remove", function(){
		recipient_id--;
		$(this).parent().remove();
	});
	
	// If the user hits enter in this field, add the recipient.
	//JQ1.9 $('#recipEmail').live('keyup', function(e) {
	$(document).on("keyup", '#recipEmail', function(e) {
		if(e.keyCode == 13) addSingleRecipient();
	});
	//JQ1.9 $('#recipName').live('keyup', function(e) {
	$(document).on("keyup", '#recipName', function(e) {
		if(e.keyCode == 13) addSingleRecipient();
	});
	
	$('#addRecipients').on('click', function(){
		// Bind facebox on reveal to focus recipName
		$(document).on('reveal.facebox', function() {
                  $('#recipName').trigger('focus')
                });
		// Show the dialog.
		$.facebox(DropOff.addRecipients);
		addAddressBook();
	});

	// Bind an event to facebox's close event
	//JQ $(document).bind('afterClose.facebox', function(){
	$(document).on('afterClose.facebox', function(){
		// Focus on the 'note' element
		$('#note').trigger('focus');
	});

	//JQ1.9 $('#addMultipleRecipients').live('click', function(){
	$(document).on('click', '#addMultipleRecipients', function(){
		addMultiple();
		return false;
	});
	
	$(document).on('click', '#showSingleDialog, #showMultipleDialog', function(){
		switch($(this).attr('id')){
			case "showSingleDialog":
				$('#showSingleDialog').removeClass('greyButton');
				$('#showMultipleDialog').addClass('greyButton');
				
				$( "#sendMultiple" ).fadeOut(200, function(){
					$( "#sendSingle" ).fadeIn(200);
				});
			break;
			case "showMultipleDialog":
				$('#showMultipleDialog').removeClass('greyButton');
				$('#showSingleDialog').addClass('greyButton');	
				
				$('#sendSingle').fadeOut(200, function(){
					$( "#sendMultiple" ).fadeIn(200);
				});
			break;
		}
	});
	
	// Get the new recipients form and copy it into a new object + remove from the DOM.
	DropOff.addRecipients = $('#addNewRecipient').html();
	$('#addNewRecipient').remove();

	// Code for dealing with selecting already uploaded files.
	if (usingLibrary == "1") {
	  var fs = $('#file_select');
	  populateSelectFileFields(fs);
	  fs.on('change', function(){
	    var selectedOption = $(this).children('option:selected');
	    var selectedFile = selectedOption.val();
	    if (selectedFile != "-1") { // Did they actually pick a file?
       	      var desc = "";
	      if (typeof selectedOption.data('info') != "undefined")
	        desc = selectedOption.data('info').description;
	      num_files++; // Pre-increment so 1st element is num_files[1]
	      file_objects[num_files] = selectedFile;
	      file_descs[num_files] = desc;
	      fileInLibrary[num_files] = true;
	      appendNewFile(num_files, selectedFile, desc, -1); // -1=>Library
	      updateTotalSize();
	      $(this).val("-1");
	      $('#uploadTable').toggle(num_files>0?true:false);
	      $('#DropoffButton').toggle(num_files>0?true:false);
	    }
	  });
	} else {
	  // Don't show the file selector or surrounding text
	  $('#libraryselector').toggle(false);
	}
});

// List the contents of the library into the file selector
function populateSelectFileFields(target){
	$.each(library, function(i, v){
          $(target).append(
            $('<option>', { html: v.filename, 'val': v.where }).data('info', v)
              );
	});
}

// Display a floating point value to "precision" decimal places
function toFixed(value, precision) {
    var precision = precision || 0,
        power = Math.pow(10, precision),
        absValue = Math.abs(Math.round(value * power)),
        result = (value < 0 ? '-' : '') + String(Math.floor(absValue / power));

    if (precision > 0) {
        var fraction = String(absValue % power),
            padding = new Array(Math.max(precision - fraction.length, 0) + 1).join('0');
        result += '.' + padding + fraction;
    }
    return result;
}

// Return an integer number of bytes in MB to 1 decimal place
function formatFileSize(size){
	if (size<0) {
          // It's a library file so doesn't consume any space at all
	  return '{t}Library{/t}';
	}
	if (size>=1048576) {
	  return toFixed(size / 1048576, 1) + " {t}MB{/t}";
	}
	return toFixed(size / 1024, 1) + " {t}KB{/t}";
}
// Return an integer number of bytes in MB to 0 decimal place
function formatMaxSize(size){
	if (size>=1048576) {
	  return toFixed(size / 1048576, 0) + " {t}MB{/t}";
	}
	return toFixed(size / 1024, 0) + " {t}KB{/t}";
}

// Is this thing a file or a directory?
// Note this code only works on a few browsers right now, but it doesn't
// cause any harm so it's staying. One day it might work, who knows?
// Does work on some Windows browsers, which is handy!
function isFile(f) {
  // Works on some Webkit
  if (typeof(f.webkitGetAsEntry) == "function") {
    return f.webkitGetAsEntry().isFile;
  }
  // Works on some other recent stuff
  if (typeof(f.getAsEntry) == "function") {
    return f.getAsEntry().isFile;
  }
  // We can't tell, so assume it is a file.
  return true;
}

// Add files that the user has chosen from local filesystem.
// This does not include library files.
function addFiles(files) {
  for(var i=0; i<files.length && num_files<{$uploadFilesMax}; i++) {
    var filei = files[i];
    if (filei.size>0 && filei.kind != 'string' && isFile(filei)) {
      num_files++; // Pre-increment so 1st element is num_files[1]
      file_objects[num_files] = filei;
      file_descs[num_files] = '';
      fileInLibrary[num_files] = false;
      appendNewFile(num_files, filei.name, '', filei.size);

      // This is an abandoned version of the inside of the "if" above.
      // I hoped a dir would fail to read with FileReader, but no such luck!
      //// To test if it's a file or a directory,
      //// let's try to read the 1st byte of it.
      //reader = new FileReader();
      //reader.onerror = function() { console.log("error occurred on file "+filei.name); };
      //reader.onabort = function() { console.log("abort occurred on file "+filei.name); };
      //// This uses an IIFE so I can synchronously pass filei
      //// into the handler (which picks it up as f)
      //reader.onload = (function(f) {
      //  // The file load (of just the 1st byte) completed successfully
      //  num_files++; // Pre-increment so 1st element is num_files[1]
      //  file_objects[num_files] = f;
      //  file_descs[num_files] = '';
      //  fileInLibrary[num_files] = false;
      //  appendNewFile(num_files, f.name, '', f.size);
      //})(filei);
      //// Now we've setup the FileReader, try to read just the 1st byte
      //var firstbyte = filei.slice(0, 0);
      //reader.readAsBinaryString(firstbyte);
    }
  }
  
  // Now replace the element with a fresh one. Otherwise
  // we can't add a file then delete it then re-add it as the element
  // still thinks that file is selected, so doesn't do anything.
  var filecopy = $('<input type="file" id="AddFiles" multiple style="display:none" onchange="addFiles(this.files)">');
  $('#AddFiles').replaceWith(filecopy);
  
  $('#uploadTable').toggle(num_files>0?true:false);
  $('#DropoffButton').toggle(num_files>0?true:false);
}

var entityMap = {
  '&': '&amp;',
  '<': '&lt;',
  '>': '&gt;',
  '"': '&quot;',
  "'": '&#39;',
  '/': '&#x2F;',
  '`': '&#x60;',
  '=': '&#x3D;'
};
function escapeHtml (string) {
  return String(string).replace(/[&<>"'`=\/]/g, function (s) {
    return entityMap[s];
  });
}

// Append a new file to the list in the UI
function appendNewFile(n, name, desc, size) {
  // Convert the inputs to usable safe strings
  var sizeString = formatFileSize(size);
  var edesc = escapeHtml(desc);
  // Remove leading sub-directory names and so on, ie everything up
  // to and including the last \ or /. ".*" is greedy.
  var ename = name.replace(/^.*[\\\/]/, '');
  ename = escapeHtml(ename);
  var f = $("<tr>", { 'id': n, 'class': 'file' });
  f.append('<td class="filelabel" for="file_'+n+'">'+n+':</td>');
  f.append('<td class="ndfilename">'+ename+'</td>');
  f.append('<td class="fileSize ndfilesize">'+sizeString+'</td>');
  f.append('<td class="filedesc" for="desc_'+n+'"><input type="text" name="desc_'+n+'" id="desc_'+n+'" onchange="saveDesc('+n+',this)" size="30" value="'+edesc+'"/></td>');
  f.append('<td class="fileremove"><a href="#_js" onclick="removeFile('+n+')"><img src="images/x.png" alt="{t}Remove file{/t}" title="{t}Remove file{/t} '+n+'" border="0" style="vertical-align: middle"></a></td>');

  $('#uploadFiles').append(f);
  updateTotalSize();
}

// The description of a file has changed, so save it
function saveDesc(n, el) {
  file_descs[n] = el.value;
}

// Remove file n from the UI (then the data on completion)
function removeFile(n) {
  if (n<=0 || n>num_files) return; // Out of valid range

  // Delete it from the relevant arrays and remove from the page
  file_objects.splice(n, 1);
  file_descs.splice(n, 1);
  fileInLibrary.splice(n, 1);
  $('#'+n).fadeOut('fast', function() { adjustTable(this, n); });
  return false;
}

// The animation has finished, so really update the table
function adjustTable(row, n) {
  $(row).remove();
  num_files--;

  if (num_files<=0) {
    // No files left, so no redraw of anything
    $('#uploadTable').toggle(false);
    $('#DropoffButton').toggle(false);
    num_files = 0;
    updateTotalSize();
    return;
  }

  // If we deleted the last row, nothing else to do except update totals
  if (n>num_files) {
    updateTotalSize();
    return;
  }

  // Now need to renumber everything from n+1 to num_files+1 down by 1
  $('#uploadFiles tr').each(function() {
    // this is a row
    var rownum = $(this).attr('id');
    var newrow = rownum-1;
    if (rownum<=n) return; // Before the ones we want to move

    $(this).attr('id', newrow);
    $(this).children().each(function() {
      // this is a td cell
      // These children are the 4 <td> elements in the row
      if ($(this).hasClass('filelabel')) {
        $(this).attr('for', 'file_'+newrow).text(newrow+':');
      } else if ($(this).hasClass('filedesc')) {
        $(this).attr('for', 'desc_'+newrow);
        // And update its child that's an "input"
        var inp = $(this).children('input').first();
        $(inp).attr('id', 'desc_'+newrow)
              .attr('name', 'desc_'+newrow)
              .removeAttr('onchange')
              .off('change');
        $(inp).on('onchange', function() { saveDesc(newrow, this); });
      } else if ($(this).hasClass('fileremove')) {
        // Only update its "a" child
        var rem = $(this).children('a').first();
        $(rem).removeAttr('onclick')
              .off('click');
        $(rem).on('click', function() { removeFile(newrow); });
        // And the img inside that
        $(rem).children('img').first().attr('title', '{t}Remove file{/t} '+newrow);
      }
    });
  });
  updateTotalSize();
}

// Obsolete now as we adjust the table rather than redraw it.
// // Redraw all the files in the UI
// function redrawFiles() {
//   var scroll = $(document).scrollTop();
// 
//   // Reset the old div to blank first.
//   // Hope that we have all the latest descriptions stored first!
//   $('#uploadFiles').empty();
// 
//   // Draw the table if there's something to put in it
//   if (num_files>0) {
//     $('#uploadTable').toggle(true);
// 
//     // Now add everything back in
//     for (var i=1; i<=num_files; i++) {
//       var f = file_objects[i];
//       appendNewFile(i, f.name, file_descs[i], fileInLibrary[i]?-1:f.size);
//     }
// 
//     $('#DropoffButton').toggle(true);
//   }
// 
//   // Don't set the time too small (<10) or else nothing happens
//   $('html, body').animate({ scrollTop: scroll }, 10, "linear");
// }

// Update the text showing the total size of all the files.
// Returns total bytes, which may be useful elsewhere.
function updateTotalSize() {
  totalbytes = 0;
  for (var i=1; i<=num_files; i++) {
    if (!fileInLibrary[i]) totalbytes += file_objects[i].size;
  }
  var s = formatFileSize(totalbytes)+" / "+formatMaxSize(maxTotalSize);
  $('#totalSize').text(s);
  // If the drop-off is too big to checksum, untick that box
  // If it's too big to checksum, untick the box.
  // Otherwise auto-tick the box unless the user has touched it.
  if (totalbytes > maxChecksumSize) {
    $('#checksumFiles').prop('checked', false);
  } else if (! checksumUnticked) {
    $('#checksumFiles').prop('checked', true);
  }
  return totalbytes;
}

function addSingleRecipient(){

    var currentName = $('#recipName').val();
    var currentEmail = $('#recipEmail').val();

	addRecipient(currentName, currentEmail);
}

function addRecipient(currentName, currentEmail){
	currentEmail = $.trim(currentEmail);
	currentName = $.trim(currentName);

  currentName = currentName.replace(/[<>]/g, '');

	if(emailRegex.test(currentEmail) == false) {
		alert("{t}Please enter a valid email address.{/t}");
		return false;
	}

	if ( currentEmail != "" ) {
	  // New data
	  var format = currentName + " &lt;" + currentEmail + "&gt;";
	  
	  var emailTemplate = $("<div>", { 'class':'emailButton', 'html': format });
	  
	  emailTemplate.append($("<a>", { 'class': 'remove', 'style': 'float:right; top:-3px; position:relative' }).append($('<img>', { src: 'images/swish/minus-circle.png', alt: '{t}Remove selected recipient{/t}' })));
	  
	  emailTemplate.append($("<input>", { 'type': 'hidden', 'name': 'recipName_' + recipient_id, 'value': currentName }));
	  emailTemplate.append($("<input>", { 'type': 'hidden', 'name': 'recipEmail_' + recipient_id, 'value': currentEmail }));
	  emailTemplate.append($("<input>", { 'type': 'hidden', 'name': 'recipient_' + recipient_id, 'value': 'recipient_id' }));
	  
	  emailTemplate.insertBefore('#emailHolder a#addRecipients');
	  
	  recipient_id++;
	  
	  clearRecipientFields();
	  $("#recipName").trigger('focus');
	}
}

function addMultiple(){
	// Get contents of text field.
	var rawData = $('#multipleRecipients').val();
	var rejectedAddresses = "";
	
	if(rawData.length == 0) return;
	
	// Pull out the lines.
	var lines = rawData.split(/\r\n|\r|\n/);
	
	for(recipient in lines){
		if( emailFormatRegex.test(lines[recipient]) ) {
			var email = emailFormatRegex.exec(lines[recipient]);
			var thisEmail = email[1];
			var thisName = lines[recipient].replace(thisEmail, "");
			
			if(emailBracketRegex.test(thisEmail)) {
				em = emailBracketRegex.exec(thisEmail);
				thisEmail = em[1];
			}
      thisName = thisName.replace(/[<>]/g, '');
			if(emailRegex.test(thisEmail) == false){
				rejectedAddresses += lines[recipient] + "\n";
				continue;
			}
			addRecipient(thisName, thisEmail);
		} else {
			rejectedAddresses += lines[recipient] + "\n";	
		}
	}
	$('#multipleRecipients').val(rejectedAddresses);
}


function clearRecipientFields(){
    $('#recipName, #recipEmail').val("");
}

function focus(el){
	$($(el)).trigger('focus');
}

function validateForm()
{
  if ( num_files < 1 ) {
    alert("{t}Please add at least one file first!{/t}");
    return false;
  }
  if ( recipient_id < 2 ) {
    alert("{t}Please add at least one recipient first!{/t}");
    return false;
  }
  if(updateTotalSize() > maxTotalSize){
    alert('{t}Your files are larger than the maximum total size you can send in one drop-off (__MAXTOTALSIZE__).{/t}'.replace('__MAXTOTALSIZE__', formatMaxSize(maxTotalSize)));
    return false;
  }
  for (var i=1; i<=num_files; i++) {
    if (!fileInLibrary[i] && file_objects[i].size > maxFileSize) {
      alert('{t}File __NUMBER__ is larger than the maximum file size you can send in a drop-off (__MAXFILESIZE__).{/t}'.replace('__NUMBER__',i).replace('__MAXFILESIZE__', formatFileSize(maxFileSize)));
      return false;
    }
  }
  return true;
}
//-->
</script>

    <div style="padding:4px;border:2px solid #C01010;background:#FFF0F0;color:#C01010;text-align:justify;" class="round">
      <strong>{t}PLEASE NOTE{/t}</strong>
      <br>
      <br>
      {t escape=no 1=#ServiceTitle# 2=#FavouriteWindowsZip#}Files uploaded to %1 are scanned for viruses.  But still exercise the same degree of caution as you would with any other file you download.  Users are also <strong>strongly encouraged</strong> to encrypt any files containing sensitive information (e.g. personal private information) using a tool such as "%2", before sending them via %1!{/t}
    </div>

{if $isAuthorizedUser}
  <p>{t 1=#OrganizationShortName#}This web page will allow you to drop-off (upload) one or more files for anyone (either a %1 user or others). The recipient will receive an automated email containing the information you enter below and instructions for downloading the file. Your IP address will also be logged and sent to the recipient for identity confirmation purposes.{/t}</p>
{else}
  <p>{t 1=#OrganizationShortName#}This web page will allow you to drop-off (upload) one or more files for a %1 user. The recipient will receive an automated email containing the information you enter below and instructions for downloading the file. Your IP address will also be logged and sent to the recipient for identity confirmation purposes.{/t}</p>
{/if}

<form name="dropoff" id="dropoff" method="post" enctype="multipart/form-data">

<!-- First box about the sender -->
<div class="UILabel">{t}From{/t}:</div> <br class="clear" />
<div id="fromHolder"><span id="fromName">{$senderName}</span> <span id="fromEmail">&lt;{$senderEmail}&gt;</span> <span id="fromOrg">{$senderOrg}</span></div>

<!-- All the tick-boxes -->
<table width="100%"><tr>
<td width="50%"><div class="fleft">
  <input type="checkbox" name="checksumFiles" id="checksumFiles" checked="checked"/> <label name="checksumFilesLabel" id="checksumFilesLabel" for="checksumFiles">{t}Calculate SHA-256 checksum of each file.{/t}</label><br />
  <input type="checkbox" name="confirmDelivery" id="confirmDelivery" checked="checked"/> <label for="confirmDelivery">{t}Send an email to me when each recipient picks up the file(s).{/t}</label>
</div></td>
<td width="50%"><div class="fright">
  <input type="checkbox" name="informRecipients" id="informRecipients" checked="checked" /> <label id="informRecipientsLabel" name="informRecipientsLabel" for="informRecipients">{t}Send e-mail message to recipients{/t}</label><br />
  <input type="checkbox" name="informPasscode" id="informPasscode" checked="checked" /> <label id="informPasscodeLabel" name="informPasscodeLabel" for="informPasscode">{t}which includes Passcode as well as Claim ID{/t}</label>
</div></td>
</table>

{* OLD CODE
<div class="fright">
  <input type="checkbox" name="informRecipients" id="informRecipients" checked="checked" /> <label id="informRecipientsLabel" name="informRecipientsLabel" for="informRecipients">{t}Send e-mail message to recipients{/t}</label><br />
  <input type="checkbox" name="informPasscode" id="informPasscode" checked="checked" /> <label id="informPasscodeLabel" name="informPasscodeLabel" for="informPasscode">{t}which includes Passcode as well as Claim ID{/t}</label><br />
  <input type="checkbox" name="confirmDelivery" id="confirmDelivery" checked="checked"/> <label for="confirmDelivery">{t}Send an email to me when each recipient picks up the file(s).{/t}</label>
</div>
OLD CODE *}

<input type="hidden" name="Action" value="dropoff"/>
<input type="hidden" id="auth" name="auth" value="{$authKey}"/>
<input type="hidden" id="req" name="req" value="{$reqKey}"/>
<input type="hidden" id="senderOrganization" name="senderOrganization" value="{$senderOrg}"/>

<br class="clear" />
<div class="UILabel">{t}To{/t}:</div> <br class="clear" />
<div id="emailHolder"> <a id="addRecipients" href="#"><img src="images/swish/plus-circle-frame.png" alt="Add recipients" /></a> </div>
<br class="clear" />


<div id="addNewRecipient">
	<h1>{t}Add Recipients{/t}</h1>
	<p id="buttonHolder" class="center">
		<button id="showSingleDialog">{t}Add One{/t}</button> <button id="showMultipleDialog" class="greyButton">{t}Add Many{/t}</button>
	</p>
	
	<!-- Sending to a single recipient -->
	<div id="sendSingle" class="center">
	<div class="ui-widget" style='margin-bottom:3px;'>
		<label for="recipName" class="UILabel">{t}Name{/t}:</label>
    	<input type="text" id="recipName" name="recipName" size="30" value="{$recipName_1}"/>
    </div>
    	<div class="ui-widget" style='margin-bottom:3px;'> 
    	<label for="recipEmail" class="UILabel">{t}Email{/t}:</label>
    	<input type="text" id="recipEmail" name="recipEmail" size="30" value="{$recipEmail_1}"/> 
    </div>
    <button onclick="javascript:addSingleRecipient();">{t}Add Recipient{/t}</button>
	</div>
	
	<div id="sendMultiple" class="center ui-widget">
	<textarea id="multipleRecipients" rows="10" cols="38" placeholder="{t}Bulk add recipients{/t}"></textarea>
	<p>{t}One recipient per line, for example:{/t} <br /><em>{t}Test User test@domain.com{/t}</em></p>
		<div class="center"><button id="addMultipleRecipients">{t}Verify{/t}</button></div>	
	</div>
</div>

	<div class="UILabel" style="width:auto">{t}Short note to the Recipients{/t}:</div> <br class="clear" />
	<table>
	  <tr><td><textarea name="note" id="note" wrap="soft" style="width:450px;height:70px">{$note}</textarea></td></tr>
	  <tr><td><span id="noteLengthText" style="float:right"></span></td></tr>
	</table>


<input type="file" id="AddFiles" multiple style="display:none" onchange="addFiles(this.files)">
<div class="center" style="margin-top:20px"><button id="AddFilesButton">{t}Add Files{/t}</button><span id="libraryselector"> <select id="file_select" name="file_select" class="file_select"><option value="-1">{t}and/or select a file...{/t}</option></select></span></div>

<table id="uploadTable" width="100%" border="0" cellpadding="5">
  <tr valign="top">
   <td> </td>
   <td>
    <table class="UD_form" cellpadding="4">
      <thead class="UD_form_header"><tr>
        <td> </td>
        <td>{t}Filename{/t}</td>
        <td class="ndfilesize">{t}Size{/t}</td>
        <td colspan="2">{t}Description{/t}</td>
      </tr></thead>
      <tbody id="uploadFiles">
      </tbody>
    </table>
   </td>
  </tr>
</table>

</form>

<script type="text/javascript">
function submitform() {
  if (validateForm()) {
    // Switch off all the drag and drop functionality
    //$('#container').off('drag dragstart dragend dragover dragenter dragleave drop');
    $('#note').off("keyup", updateNoteLength);
    // Disable all the buttons
    $('#AddFilesButton').prop('disabled', true).addClass('greyButton');
    //                    .off("click");
    $('#RealDropoffButton').prop('disabled', true).addClass('greyButton');
    $('#file_select').prop('disabled', true);
    showUpload();
    scroll(0,0);
    ignore_unload = false;

    var form = document.forms.namedItem("dropoff");
    var oData = new FormData(form);

    // Add the objects for each of the files
    for (var i=1; i<=num_files; i++) {
      if (fileInLibrary[i]) {
        oData.append('file_select_'+i, file_objects[i]);
      } else {
        oData.append('file_'+i, file_objects[i]);
      }
      oData.append('desc_'+i, file_descs[i]);
    }

    $.ajax({
        xhr: function() {
          var xhr = new window.XMLHttpRequest();
          xhr.upload.addEventListener("progress", function(e) {
            var pc = Math.floor((e.loaded*100)/e.total);
            // pc = Math.min(100, Math.max(0, pc)); // Limit to 0-100 for safety
            var c = (Math.max((pc-95)*3, 0)).toString();
            $('#progressinner').css({ "width": pc.toString()+'%', "border-radius": "15px "+c+"px "+c+"px 15px" });
            // Old code: document.getElementById('progressinner').style.cssText = 'width: '+ pc + '%; border-radius: 15px '+Math.max((pc-95)*3,0)+'px '+Math.max((pc-95)*3,0)+'px 15px;';
            if (pc == 100) {
              $('#percentText').text("{t}Scanning for viruses...{/t}");
              // Old code: document.getElementById('percentText').innerText = "{t}Scanning for viruses...{/t}";
            } else {
              $('#percentText').text("{t}Uploaded: __PERCENT__%{/t}".replace("__PERCENT__", pc.toString()));
              // Old code: document.getElementById('percentText').innerText = "{t}Uploaded: __PERCENT__%{/t}".replace("__PERCENT__", pc.toString());
            }
          }, false);
          return xhr;
        },
        method: "POST",
        url: "{$zendToURL}dropoff.php",
        // JKF not allowed to do this: headers: { Connection: 'close' },
        data: oData,
        cache: false,
        // contentType: "multipart/form-data",
        contentType: false,
        processData: false,
        // dataType:    'html', // Trying this out
        // This used to never get called by Safari, but does now.
        complete: function(jqXHR, status) {
          ignore_unload = true;
          if (status == "success") {
            var dropOffPage = $(jqXHR.responseText);
            {if $SMTPdebug}
              // Butt ugly, but you can see the debug output necessary.
              $('#container').html(dropOffPage);
            {else}
              $('#container').html(dropOffPage.children('#container').children('#dropoff-inner'));
            {/if}
            $('.ui-helper-hidden-accessible div').hide();
          } else {
            // The upload failed for some reason
            hideUpload();
            alert("{t escape=no}Sorry, I failed to drop-off your files!{/t}\n{t escape=no}Note that you cannot drop-off directories, only files.{/t}");
            // Put the form back into a working state again
            $('#uploadTable').toggle(true);
            $('#DropoffButton').toggle(true);
            $('#note').on("keyup", updateNoteLength);
            $('#AddFilesButton').prop('disabled', false)
                                .removeClass('greyButton');
            $('#RealDropoffButton').prop('disabled', false)
                                .removeClass('greyButton');
            $('#file_select').prop('disabled', false);
          }
        }
    });
  }
}
</script>

<div id="uploadDialog" style="display: none;">
  <h1>{t}Uploading...{/t}</h1>
  <div id="progressBarContainer" style="border: none; height: 80px; width: 350px; margin-left: 25px;">
    <div id="progressContainer">
      <div id="progressouter" style="display: block; margin-bottom: 10px;">
        <div id="progressinner" style="width:0%;"></div>
      </div>
      <div id="percentText" style="visibility:visible;"></div>
    </div>
  </div>
</div>

<div class="center" id="DropoffButton"><span id="totalSize"></span><br /><button id="RealDropoffButton" onclick="submitform();">{t}Drop-off Files{/t}</button></div>

<div id="overlay" style="display:none">
  <span id="overlaytext">{t escape=no}Drop to<br/>Add Files{/t}<br/><span id="overlaytextsub">{t}(It will copy, not move){/t}</span></span>
</div>

{include file="footer.tpl"}
